import javax.swing.*;
import java.util.*;
import java.awt.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class CACanvas extends JPanel{

  private Image image;             /* An image to draw onto whic can
				     * be coppied to the screen each time
				     * we have to paint the screen.
				     * Could this be double buffering?
				     */
  Rules rule;
  Grid myGrid;
  int mode,radioMode=0;
  int layer,height,width;
  String ruleName,patternName;
  static int COMPLETE=0;
  Vector oldLayer,newLayer,tempLayer;
  Cell seed;
  int zoomLevel;
  int xcells,ycells;  /* # of horizontal and vertical hexagons respectively */
  private Graphics imagegraphics;  /* The graphics of our image */

  public CACanvas() {

  mode=0;
  layer=0;
  ruleName = "Light Floral";
  patternName = "Reflection";
  zoomLevel=3;
  }

  public void setRuleName(String name)
  {
    ruleName = name;
  }

  public void setPatternName(String name)
  {
    patternName = name;
  }

  public int getMode()
  {
      return mode;
  }

  public void setMode(int val)
  {
      mode = val;
  }

  public void paint(Graphics g)
  {
     if(image!=null)
        g.drawImage(image, 0, 0, this);
   }

  public void update( Graphics g )
  {
     paint( g );
  }

  public void initCanvas()
  {
    height = getSize().height;
    width = getSize().width;

    //System.out.println("height="+height+"width="+width);
    xcells = width/Cell.hexWidth;
    ycells = (2*Cell.hexHeight)/3;
    ycells = height/ycells;
    //System.out.println("xcells="+xcells+"ycells="+ycells);
    myGrid = new Grid(xcells*2,ycells*2);
    oldLayer=new Vector();
    newLayer=new Vector();

    if(image==null)
    {
      image = this.createImage(width, height);
      imagegraphics = image.getGraphics();
    }
    drawGrid();
    repaint();
  }

  public void drawGrid()
  {
      boolean done=true;

      seed = new Cell(width/2,height/2,ycells,xcells);
      myGrid.addCellToGrid(seed);
      myGrid.setGridCell(seed.gridx,seed.gridy,Grid.DONE);
      seed.drawCell(imagegraphics,myGrid);
      oldLayer.addElement(seed);
      while(done)
      {
        for(int i=0;i<oldLayer.size();i++)
        {
          Cell oldcell = (Cell)oldLayer.elementAt(i);
          myGrid.getNeighbours(oldcell,newLayer,1);
          for(int j=0;j<newLayer.size();j++)
          {
            Cell newcell = (Cell) newLayer.elementAt(j);
            myGrid.setGridCell(newcell.gridx,newcell.gridy,Grid.DONE);
          }
        }
         for(int j=0;j<newLayer.size();j++)
          {
            Cell newcell = (Cell) newLayer.elementAt(j);
            myGrid.addCellToGrid(newcell);
            newcell.drawCell(imagegraphics,myGrid);
          }
        oldLayer.removeAllElements();
        if(newLayer.size() == 0)
          done=false;
        tempLayer = oldLayer;
        oldLayer = newLayer;
        newLayer = tempLayer;
      }
      myGrid.initGrid();
  }

  public void startSnowflake(int radio)
  {
    radioMode = radio;
    if(radio==0)
      setRule(ruleName);
    setMode(1);
  }

  public void setRule(String item)
  {
      if(item.equals("Light Floral"))
        rule = new Snowflake1();
      else if(item.equals("Dark Floral"))
        rule = new Snowflake2();
      else if(item.equals("Mosaic"))
        rule = new Snowflake3();
      else if(item.equals("Snow Quilt"))
        rule = new Snowflake4();
      else if(item.equals("Gray Flash"))
        rule = new Snowflake5();
      else if(item.equals("Carpet Design1"))
        rule = new Snowflake6();
      else if(item.equals("Most Beautiful")) /* amazing rule seen in 2/3 hex size*/
        rule = new Snowflake7();
      else if(item.equals("Spider Cobweb")) /* simple one..layer after layer*/
        rule = new Snowflake8();
      else if(item.equals("Flashy"))
        rule = new Snowflake9();
      else if(item.equals("Carpet Design2"))
        rule = new Snowflake10();
  }

  public void processRule()
  {
    int x,y;
    COMPLETE = 1;
     for(int i=0;i<myGrid.height;i++)
     {
        for(int j=0;j<myGrid.width;j++)
        {
          Cell newcell = myGrid.getHexCell(i,j);
           if(newcell!=null)
           {
//            myGrid.getNeighbours(newcell,newLayer);
              if(radioMode == 1)
                myGrid.applyHexlife(newcell);
              else
                myGrid.apply(newcell,rule);
              x = newcell.gridx; y=newcell.gridy;
                if(myGrid.prevbuf[x][y] != myGrid.grid[x][y])
                newcell.fillCell(imagegraphics,myGrid);
//            myGrid.setGridCell(newcell.gridx,newcell.gridy,layer+1);
           }
         }
      }
      myGrid.updatePrevBuff();
   repaint();
   COMPLETE=2;
  }

  public int getPrevLayer(int x, int y)
  {
      return(myGrid.getStatus(x,y));
  }
  public void resumeSnowflake()
  {
        setMode(2);
  }

  public void mouseClicked(int x, int y, boolean radio)
  {
      if(radio)
        radioMode = 0;
      else
        radioMode = 1;
      myGrid.MarkClickedCell(imagegraphics,x,y,radioMode);
      repaint();
  }

  public void clearSnowflake()
  {
      imagegraphics.setColor(Color.white);
      imagegraphics.fillRect(0, 0, width, height);
      oldLayer.removeAllElements();
      newLayer.removeAllElements();
      myGrid.initGrid();
      drawGrid();
      repaint();
  }

  public void zoomChange(int zoom)
  {
      while(COMPLETE==1)
      {}
      Grid prevGrid=myGrid;
      Cell.hexHeight = 3 * zoom;
      Cell.hexWidth = 2 * zoom;
      zoomLevel = zoom;
      imagegraphics.setColor(Color.white);
      imagegraphics.fillRect(0, 0, width, height);
      initCanvas();
      myGrid.copyGrid(prevGrid,imagegraphics);
      repaint();
  }

  public void setHexLifePattern()
  {
      if(patternName.equals("Reflection"))
      {
          clearSnowflake();
          myGrid.setReflectionPattern(imagegraphics,xcells,ycells);
      }
      else if(patternName.equals("Dancing Dots"))
      {
         clearSnowflake();
         myGrid.setPattern(imagegraphics,zoomLevel,patternName);
      }
      else if(patternName.equals("Gliders"))
      {
         clearSnowflake();
         myGrid.setPattern(imagegraphics,zoomLevel,patternName);
      }
      else if(patternName.equals("Fixed Spiders"))
      {
        clearSnowflake();
        myGrid.setPattern(imagegraphics,zoomLevel,patternName);
      }
  }

  public void stopSnowflake()
  {
      //setMode(STOP);
  }
}
