/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.util.*;
public class Grid {

  int grid[][];
  Cell hexcell[][];
  int height;
  int width;
  int prevbuf[][];
  static int BLACK=1;
  static int WHITE=0;
  static int GRAY=2;
  static int BLUE=3;
  static int RED=4;
  static int DARKGRAY=5;
  static int CYAN=6;
  static int GREEN = 7;
  static int DONE=-1;

  public Grid(int width,int height)
  {
    this.height = height;
    this.width = width;
    grid = new int [height][width];
    prevbuf = new int [height][width];
    hexcell = new Cell [height][width];
    initGrid();
  }

  public void initGrid()
  {
     for(int i=0;i<height;i++)
      for(int j=0;j<width;j++)
      {
        grid[i][j] = WHITE;
        prevbuf[i][j] = WHITE;
      }
  }

  Color getColor(int x, int y)
  {
    if(grid[x][y] == BLACK)
      return(Color.black);
    else if(grid[x][y] == GRAY)
      return(Color.gray);
     else if(grid[x][y] == CYAN)
      return(Color.cyan);
     else if(grid[x][y] == DARKGRAY)
      return(Color.darkGray);
     else if(grid[x][y] == BLUE)
      return(Color.blue);
       else if(grid[x][y] == RED)
      return(Color.red);
      else if(grid[x][y] == GREEN)
      return(Color.green);
    return (Color.white);
  }

  void setColor(Color col,int x, int y)
  {
    grid[x][y] = WHITE;
    if(col == Color.black)
      grid[x][y] = BLACK;
    if(col == Color.gray)
      grid[x][y] = GRAY;
     if(col == Color.red)
      grid[x][y] = RED;
     if(col == Color.cyan)
      grid[x][y] = CYAN;
       if(col == Color.darkGray)
      grid[x][y] = DARKGRAY;
       if(col == Color.blue)
      grid[x][y] = BLUE;
      if(col == Color.green)
      grid[x][y] = GREEN;
  }

  void getNeighbours(Cell oldcell,Vector newLayer,int create)
  {
      int i,newhX=0,newhY=0,newgX=0,newgY=0;
      int x = oldcell.x;
      int y = oldcell.y;
      int gx = oldcell.gridx ;
      int gy = oldcell.gridy ;
      Cell newcell;
      for(i=1;i<=6;i++)
      {
        switch(i)
        {
          case 1:newhX = x-Cell.hexWidth;
                 newgX = gx;
                 newhY = y;
                 newgY = gy-2;
                break;
          case 2: newhX = x-(Cell.hexWidth/2);
                 newgX = gx-2;
                 newhY = y-((2*Cell.hexHeight)/3) ;
                 newgY = gy-1;
                 break;
          case 3:newhX = x+(Cell.hexWidth/2);
                 newgX = gx-2;
                 newhY = y-((2*Cell.hexHeight)/3) ;
                 newgY = gy+1;
                 break;
          case 4:newhX = x+Cell.hexWidth;
                 newgX = gx;
                 newhY = y;
                 newgY = gy+2;
                 break;
          case 5:newhX = x+(Cell.hexWidth/2);
                 newgX = gx+2;
                 newhY = y+((2*Cell.hexHeight)/3);
                 newgY = gy+1;
                 break;
          case 6:newhX = x-(Cell.hexWidth/2);
                 newgX = gx+2;
                 newhY = y+((2*Cell.hexHeight)/3);
                 newgY = gy-1;
                break;
        }
        try{
        if(checkBoundary(newgX,newgY))
          continue;
        if(getStatus(newgX,newgY) == Grid.DONE)
          continue;
        } catch (ArrayIndexOutOfBoundsException e)
        {
           System.out.println(e.getMessage());
        }
        if(create == 1)
          newcell = new Cell(newhX,newhY,newgX,newgY);
        else
          newcell = getHexCell(newgX,newgY);
        newLayer.addElement(newcell);
      }
  }
  void applyHexlife(Cell currcell)
  {
     int i,newgX=0,newgY=0;
      int gx = currcell.gridx ;
      int gy = currcell.gridy ;
      double sum=0;

      for(i=1;i<=12;i++)
      {
        switch(i)
        {
          case 1: newgX = gx;
                  newgY = gy-2;
                  break;
          case 2: newgX = gx-2;
                  newgY = gy-1;
                  break;
          case 3: newgX = gx-2;
                  newgY = gy+1;
                  break;
          case 4: newgX = gx;
                  newgY = gy+2;
                  break;
          case 5: newgX = gx+2;
                  newgY = gy+1;
                  break;
          case 6: newgX = gx+2;
                  newgY = gy-1;
                  break;
          case 7: newgX = gx-2;
                  newgY = gy-3;
                  break;
          case 8: newgX = gx+2;
                  newgY = gy-3;
                  break;
          case 9: newgX = gx+4;
                  newgY = gy;
                  break;
          case 10: newgX = gx+2;
                  newgY = gy+3;
                  break;
          case 11: newgX = gx-2;
                  newgY = gy+3;
                  break;
          case 12: newgX = gx-4;
                  newgY = gy;
                  break;
        }
        if(newgX < 0 || newgX >= height || newgY < 0 || newgY >= width)
        {
           // col[i-1] = Color.white;
            continue;
        }
        if(prevbuf[newgX][newgY] != WHITE )  /*live*/
        {
            if(i<=6)
              sum+=1;
            else
              sum+=0.3;
        }
      }
      if(prevbuf[gx][gy] == WHITE)
      {
          if(sum >= 2.3 && sum <=2.9) /*becomes alive 0->1*/
            setColor(Color.blue,currcell.gridx,currcell.gridy);
      }
      else
      {
          if(!(sum >=2.0 && sum <= 3.3))
            setColor(Color.white,currcell.gridx,currcell.gridy);
          else
            setColor(Color.green,currcell.gridx,currcell.gridy);
      }
  }
/* find the color( state) of the neighbouring cells and call the appyRule method to apply the rule*/
  void apply(Cell currcell,Rules rule)
  {
      int i,newgX=0,newgY=0;
      int gx = currcell.gridx ;
      int gy = currcell.gridy ;
      int sevenSum=prevbuf[gx][gy];

      for(i=1;i<=6;i++)
      {
        switch(i)
        {
          case 1: newgX = gx;
                  newgY = gy-2;
                  break;
          case 2: newgX = gx-2;
                  newgY = gy-1;
                  break;
          case 3: newgX = gx-2;
                  newgY = gy+1;
                  break;
          case 4: newgX = gx;
                  newgY = gy+2;
                  break;
          case 5: newgX = gx+2;
                  newgY = gy+1;
                  break;
          case 6: newgX = gx+2;
                  newgY = gy-1;
                  break;
        }
        if(newgX < 0 || newgX >= height || newgY < 0 || newgY >= width)
        {
           // col[i-1] = Color.white;
            continue;
        }
        sevenSum+=prevbuf[newgX][newgY];
      }
      setColor(rule.applyRule(sevenSum),currcell.gridx,currcell.gridy );
  }

  boolean checkBoundary(int x,int y)
  {
      if(x < 0 || x >= height || y < 0 || y >= width)
      {
         return true;
      }
      return false;
  }

  public void addCellToGrid(Cell c)
  {
      int x = c.gridx;
      int y = c.gridy;
      hexcell[x][y] = c;
  }

  public void MarkClickedCell(Graphics g, int x, int y,int radioMode)
  {
      boolean done=false;
      for(int i=0;i<height && done==false;i++)
      {
        for(int j=0;j<width;j++)
        {
            if(hexcell[i][j]!=null)
            {
                if(hexcell[i][j].pointPresentInHexCell(x,y)==true)
                {
                    if(prevbuf[i][j] == BLACK || prevbuf[i][j] == BLUE )
                    {
                      setColor(Color.white,hexcell[i][j].gridx,hexcell[i][j].gridy);
                      prevbuf[i][j] = WHITE;
                    }
                    else
                    {
                      if(radioMode == 1)
                      {
                         setColor(Color.blue,hexcell[i][j].gridx,hexcell[i][j].gridy);
                         prevbuf[i][j] = BLUE;
                      }
                      else
                      {
                        setColor(Color.black,hexcell[i][j].gridx,hexcell[i][j].gridy);
                        prevbuf[i][j] = BLACK;
                      }
                   //   System.out.println("x= "+x+"y= "+y);
                    }
                    hexcell[i][j].fillCell(g, this);
                    done=true;
                    break;
                }
            }
        }
      }
  }

  public void updatePrevBuff()
  {
      int i,j;
      for(i=0;i<height;i++)
      {
        for(j=0;j<width;j++)
        {
            prevbuf[i][j] = grid[i][j];
        }
      }
  }

  public void copyGrid(Grid prevGrid, Graphics g)
  {
      Vector oldLayer,newLayer,tempLayer;
//      Vector oldLayer1,newLayer1;
      int centerx,centery,newcenterx,newcentery,p1,p2;
      boolean done=true;

      oldLayer=new Vector();
      newLayer=new Vector();
    /*  oldLayer1=new Vector();
      newLayer1=new Vector();*/

      centerx = prevGrid.height/2;
      centery = prevGrid.width/2;
      newcenterx = height/2;
      newcentery = width/2;

      Cell seed = prevGrid.getHexCell(centerx,centery);
      Cell seed1 = getHexCell(newcenterx,newcentery);
      oldLayer.addElement(seed);
//      oldLayer1.addElement(seed1);
      setGridCell(seed1.gridx ,seed1.gridy ,prevGrid.getStatus(seed.gridx,seed.gridy));
      seed1.fillCell(g,this);
      prevGrid.setGridCell(seed.gridx,seed.gridy,Grid.DONE);
      while(done)
      {
        for(int i=0;i<oldLayer.size();i++)
        {
          Cell oldcell = (Cell)oldLayer.elementAt(i);
          prevGrid.getNeighbours(oldcell,newLayer,0);
        //  Cell oldcell1 = (Cell)oldLayer1.elementAt(l);
       //   getNeighbours(oldcell1,newLayer1,0);
          for(int j=0;j<newLayer.size();j++)
          {
             Cell newcell = (Cell) newLayer.elementAt(j);

             p1 = newcenterx + newcell.gridx - centerx;
             p2 = newcentery + newcell.gridy - centery;
             if(checkBoundary(p1,p2))
             {
                 prevGrid.setGridCell(newcell.gridx,newcell.gridy,Grid.DONE);
                 continue;
             }
             Cell newcell1 = getHexCell(p1,p2);
             if(prevGrid.getStatus(newcell.gridx,newcell.gridy)!= Grid.DONE)
             {
                setGridCell(newcell1.gridx,newcell1.gridy,prevGrid.getStatus(newcell.gridx,newcell.gridy));
                newcell1.fillCell(g,this);
                prevGrid.setGridCell(newcell.gridx,newcell.gridy,Grid.DONE);
             }
          }

        }
        oldLayer.removeAllElements();
       // oldLayer1.removeAllElements();
        if(newLayer.size() == 0)
          done=false;
        tempLayer = oldLayer;
        oldLayer = newLayer;
        newLayer = tempLayer;
      }
      updatePrevBuff();
  }

  Cell getHexCell(int i,int j)
  {
    if(i>=0 && i<height && j<width && j>=0)
      return(hexcell[i][j]);
    else
      return null;
  }

  int getStatus(int x, int y)
  {
      return(grid[x][y]);
  }
  void setGridCell(int x, int y,int stat)
  {
      grid[x][y] = stat;
  }
  void setReflectionPattern(Graphics g,int cy,int cx)
  {
      int i,j;
      Cell mcell = getHexCell(cx,cy);
      MarkClickedCell(g, mcell.x,mcell.y,1);
      mcell = getHexCell(cx+2,cy-1);
      MarkClickedCell(g, mcell.x,mcell.y,1);
      mcell = getHexCell(cx,cy-2);
      MarkClickedCell(g, mcell.x,mcell.y,1);
  }
  void setPattern(Graphics g,int zoomLevel,String name)
  {
      int spacing=0,coun=0,k,padding=0;
      int i,j,inc;
      boolean flag;
      Random ra = new Random();

      switch(zoomLevel)
      {
        case 1:
        case 2:
        case 3:
        case 4:
        case 5: spacing=20;
                padding=20;
                break;
        case 6: spacing=16;
                padding = 12;
                break;
        case 7: spacing=14;
                padding = 10;
                break;
        case 8: spacing=22;
                padding = 8;
                break;
        case 9: spacing=21;
                padding = 8;
                break;
        case 10: spacing=20;
                padding = 8;
                break;
      }
      i=0;
      inc=0;

      while(i<height)
      {
        j=inc+padding;
        flag=false;
        while(j<(width-padding))
        {
            if(getHexCell(i,j)!=null)
            {
                flag=true;
                if(name.equals("Gliders"))
                  drawGlider(i,j,g);
                else if(name.equals("Dancing Dots"))
                  drawDancing(i,j,g);
                else if(name.equals("Fixed Spiders"))
                  drawFixedSpiders(i,j,g);
                for(k=j,coun=0;k<width&& coun < spacing;k++)
                {
                    if(getHexCell(i,k)!=null)
                       coun++;
                }
                j+=coun;
            }
            else
              j++;
        }
        if(flag)
          i+=spacing;
        else
          i++;
        inc = ra.nextInt(3);
      }
  }
  void drawDancing(int i,int j,Graphics g)
  {
     Cell mcell = getHexCell(i,j);
     MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+2,j+1);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+4,j+2);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+4,j+4);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+2,j+5);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);
  }

  void drawGlider(int i,int j,Graphics g)
  {
     Cell mcell = getHexCell(i,j);
     MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+2,j+1);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+4,j+2);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+6,j+1);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+6,j-1);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);
  }

  void drawFixedSpiders(int i,int j,Graphics g)
  {
     Cell mcell = getHexCell(i,j);
     MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i,j+2);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i-2,j+3);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i,j+6);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+2,j+3);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);

     mcell = getHexCell(i+4,j);
     if(mcell!=null)
       MarkClickedCell(g, mcell.x,mcell.y,1);
  }
}

