import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class MyCA extends JApplet implements Runnable{

  private Thread snowflake;

  protected CACanvas canvas;
  protected JPanel controlPanel,choicePanel,togglePanel;
  JButton startButton,stopButton,resumeButton,clearButton,loadButton;
  JComboBox ruleBox,hexPatterns;
  JLabel label,zoomLabel,delayLabel;
  JSlider slider,delaySlider;
  JRadioButton hexRadio,snowRadio;
  ButtonGroup bg;
  final static int START = 1;
  final static int STOP = 0;
  final static int RESUME = 2;
  int width,height,delay=0;
  /**Construct the applet*/
  public MyCA() {
  getContentPane().setLayout(new BorderLayout());
  canvas = new CACanvas();
  getContentPane().add(canvas, BorderLayout.CENTER);
  controlPanel = new JPanel();
  controlPanel.setLayout(new BorderLayout());
  togglePanel = new JPanel();
  togglePanel.setLayout(new FlowLayout(FlowLayout.LEFT,5,0));

  hexRadio = new JRadioButton("HexLife",false);
  snowRadio = new JRadioButton("Snowflakes",true);
  bg = new ButtonGroup();
  bg.add(hexRadio);
  bg.add(snowRadio);

  controlPanel.add(togglePanel,BorderLayout.NORTH);

  choicePanel = new JPanel();
  choicePanel.setLayout(new FlowLayout(FlowLayout.LEFT,5,0));

  hexPatterns = new JComboBox();
  hexPatterns.addItem("Reflection");
  hexPatterns.addItem("Dancing Dots");
  hexPatterns.addItem("Gliders");
  hexPatterns.addItem("Fixed Spiders");

  loadButton = new JButton("Load HexLife Pattern");
  ruleBox = new JComboBox();
  ruleBox.addItem("Light Floral");
  ruleBox.addItem("Dark Floral");
  ruleBox.addItem("Mosaic");
  ruleBox.addItem("Snow Quilt");
  ruleBox.addItem("Gray Flash");
  ruleBox.addItem("Carpet Design1");
  ruleBox.addItem("Most Beautiful");
  ruleBox.addItem("Spider Cobweb");
  ruleBox.addItem("Flashy");
  ruleBox.addItem("Carpet Design2");

  label = new JLabel("Snowflake Rule");
  zoomLabel = new JLabel("Zoom");
  slider = new JSlider(JSlider.HORIZONTAL,1, 10, 3);
  slider.setMajorTickSpacing(1);
  slider.setPaintTicks(true);
  slider.setPaintLabels(true);
  slider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));

  delayLabel = new JLabel("Delay",JLabel.TRAILING);
  delaySlider = new JSlider(JSlider.HORIZONTAL,1,5,1);

  togglePanel.add(snowRadio);
  togglePanel.add(label);
  togglePanel.add(ruleBox);
  choicePanel.add(hexRadio);
  choicePanel.add(loadButton);
  choicePanel.add(hexPatterns);
  //choicePanel.add(label);
  //choicePanel.add(ruleBox);
  choicePanel.add(zoomLabel);
  choicePanel.add(slider);

  controlPanel.add(choicePanel,BorderLayout.CENTER);

  startButton = new JButton("Start");
  stopButton = new JButton("Stop");
  resumeButton = new JButton("Resume");
  clearButton = new JButton("Clear");
  JPanel buttonPanel = new JPanel();
  buttonPanel.setLayout(new GridLayout(1, 6, 3, 5));
  buttonPanel.add(startButton);
  buttonPanel.add(resumeButton);
  buttonPanel.add(stopButton);
  buttonPanel.add(clearButton);
  buttonPanel.add(delayLabel);
  buttonPanel.add(delaySlider);

  controlPanel.add(buttonPanel,BorderLayout.SOUTH);

  getContentPane().add(controlPanel,BorderLayout.SOUTH);

  slider.addChangeListener(new ChangeListener(){
    public void stateChanged(ChangeEvent e) {
     jSliderZoom_stateChanged(e);}
  });

  delaySlider.addChangeListener(new ChangeListener(){
    public void stateChanged(ChangeEvent e) {
     jSliderDelay_stateChanged(e);}
  });

  canvas.addMouseListener(new java.awt.event.MouseAdapter(){
    public void mouseClicked(MouseEvent e)
    {
        canvas.mouseClicked(e.getX(),e.getY(),snowRadio.isSelected());
    }
  });
  startButton.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
        jButtonStart_actionPerformed(e);
      }
    });

  resumeButton.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jButtonResume_actionPerformed(e);
      }
    });
  stopButton.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jButtonStop_actionPerformed(e);
      }
    });
   clearButton.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jButtonClear_actionPerformed(e);
      }
    });
   ruleBox.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jRuleBox_actionPerformed(e);
      }
    });
     hexPatterns.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jHexPatterns_actionPerformed(e);
      }
    });
     loadButton.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(ActionEvent e) {
        jButtonLoad_actionPerformed(e);
      }
    });
 }

  /**Initialize the applet*/
  public void init() {
    try{width = Integer.parseInt(getParameter("width")); }
      catch(NumberFormatException e){width = 500;}

    try{height = Integer.parseInt(getParameter("height")); }
      catch(NumberFormatException e){height = 400;}
    setBackground(Color.white);
    canvas.setSize(600,437);
    canvas.initCanvas();
  }
   // Called when he applet starts
   public void start() {
      snowflake = new Thread(this);
      snowflake.start();
   }

   // Called when the aplet stops
   public void stop() {
      snowflake.stop();
   }

  public void run() {

      while (true) {
	 try {Thread.currentThread().sleep(delay);}
	 catch (InterruptedException e){;}
         int action = canvas.getMode();
          if( action == START || action == RESUME)
          {
            canvas.processRule();
          }
       }
   }

  void jButtonStart_actionPerformed(ActionEvent e) {
    clearButton.setEnabled(false);
    startButton.setEnabled(false);
    if(snowRadio.isSelected())
      canvas.startSnowflake(0);
    else
      canvas.startSnowflake(1);
  }

  void jButtonResume_actionPerformed(ActionEvent e) {
       clearButton.setEnabled(false);
       startButton.setEnabled(false);
       canvas.resumeSnowflake();
  }

  void jButtonStop_actionPerformed(ActionEvent e) {
     clearButton.setEnabled(true);
      startButton.setEnabled(true);
     canvas.setMode(STOP);
  //  canvas.stopSnowflake();
  }
  void jButtonClear_actionPerformed(ActionEvent e)
  {
      canvas.clearSnowflake();
  }

  void jButtonLoad_actionPerformed(ActionEvent e)
  {
    int action = canvas.getMode();
    if(action!=START && action!=RESUME)
      if(hexRadio.isSelected())
        canvas.setHexLifePattern();
  }

  public void jSliderZoom_stateChanged(ChangeEvent e)
  {
     JSlider source = (JSlider)e.getSource();
     if (!source.getValueIsAdjusting())
     {
	 int fps = (int)source.getValue();
         int mode = canvas.getMode();
         canvas.setMode(STOP);
         canvas.zoomChange(fps);
         if(mode == START)
           canvas.setMode(RESUME);
         else
           canvas.setMode(mode);
     }

  }

  public void jSliderDelay_stateChanged(ChangeEvent e)
  {
    JSlider source = (JSlider)e.getSource();
     if (!source.getValueIsAdjusting())
     {
	 int fps = (int)source.getValue();
         delay = (fps-1) * 100;
     }
  }

  void jRuleBox_actionPerformed(ActionEvent e) {
    String item = (String) ruleBox.getSelectedItem();
    canvas.setRuleName(item);
  //  canvas.stopSnowflake();
  }
  void jHexPatterns_actionPerformed(ActionEvent e)
  {
     String item = (String) hexPatterns.getSelectedItem();
     canvas.setPatternName(item);
  }
}